"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
var napa = require("../lib/index");
var nodeNapaPerfComp = require("./node-napa-perf-comparison");
var executeOverhead = require("./execute-overhead");
var executeScalability = require("./execute-scalability");
var transportOverhead = require("./transport-overhead");
var storeOverhead = require("./store-overhead");
function bench() {
    // Non-zone related benchmarks.
    transportOverhead.bench();
    storeOverhead.bench();
    // Create zones for execute related benchmark.
    var singleWorkerZone = napa.zone.create('single-worker-zone', { workers: 1 });
    var multiWorkerZone = napa.zone.create('multi-worker-zone', { workers: 8 });
    return nodeNapaPerfComp.bench(singleWorkerZone)
        .then(function () { return executeOverhead.bench(singleWorkerZone); })
        .then(function () { return executeScalability.bench(multiWorkerZone); });
}
exports.bench = bench;
bench();
