"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license.
Object.defineProperty(exports, "__esModule", { value: true });
var binding = require('../binding');
/// <summary> Export Crt allocator from napa.dll. </summary>
exports.crtAllocator = binding.getCrtAllocator();
/// <summary> Export default allocator from napa.dll. </summary>
exports.defaultAllocator = binding.getDefaultAllocator();
/// <summary> Create a debug allocator around allocator. </summary>
/// <param name="allocator"> User allocator. </param>
function debugAllocator(allocator) {
    return new binding.AllocatorDebuggerWrap(allocator);
}
exports.debugAllocator = debugAllocator;
