"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license.
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var zone = require("./zone/zone");
var impl = require("./zone/zone-impl");
var platform = require("./runtime/platform");
var binding = require('./binding');
/// <summary> Creates a new zone. </summary>
/// <summary> A unique id to identify the zone. </summary>
/// <param name="settings"> The settings of the new zone. </param>
function create(id, settings) {
    if (settings === void 0) { settings = zone.DEFAULT_SETTINGS; }
    platform.initialize();
    return new impl.ZoneImpl(binding.createZone(id, settings));
}
exports.create = create;
/// <summary> Returns the zone associated with the provided id. </summary>
function get(id) {
    platform.initialize();
    return new impl.ZoneImpl(binding.getZone(id));
}
exports.get = get;
Object.defineProperty(exports, "current", {
    get: function () {
        platform.initialize();
        return new impl.ZoneImpl(binding.getCurrentZone());
    }
});
Object.defineProperty(exports, "node", {
    get: function () {
        platform.initialize();
        return new impl.ZoneImpl(binding.getZone('node'));
    }
});
__export(require("./zone/zone"));
