import { Handle } from './handle';
import { Shareable } from './shareable';
export interface Allocator extends Shareable {
    allocate(size: number): Handle;
    deallocate(handle: Handle, sizeHint: number): void;
    readonly type: string;
}
export interface AllocatorDebugger extends Allocator {
    getDebugInfo(): string;
}
export declare let crtAllocator: Allocator;
export declare let defaultAllocator: Allocator;
export declare function debugAllocator(allocator: Allocator): AllocatorDebugger;
