import * as transport from "../transport";
export declare enum ZoneRecycleMode {
    AUTO = "auto",
    MANUAL = "manual",
}
export interface ZoneSettings {
    workers?: number;
    recycle?: ZoneRecycleMode;
}
export declare let DEFAULT_SETTINGS: ZoneSettings;
export declare enum TransportOption {
    AUTO = "auto",
    MANUAL = "manual",
}
export interface CallOptions {
    timeout?: number;
    transport?: TransportOption;
}
export declare let DEFAULT_CALL_OPTIONS: CallOptions;
export interface Result {
    readonly value: any;
    readonly payload: string;
    readonly transportContext: transport.TransportContext;
}
export interface Zone {
    readonly id: string;
    broadcast(source: string): Promise<void>;
    broadcast(func: (...args: any[]) => void | Promise<void>, args?: any[]): Promise<void>;
    broadcastSync(source: string): void;
    broadcastSync(func: (...args: any[]) => void | Promise<void>, args?: any[]): void;
    execute(module: string, func: string, args?: any[], options?: CallOptions): Promise<Result>;
    execute(func: (...args: any[]) => any, args?: any[], options?: CallOptions): Promise<Result>;
    recycle(): void;
    on(event: string, func: (...args: any[]) => void): void;
}
